Code

require_work_tree broken with NONGIT_OK
[git.git] / git-sh-setup.sh
1 #!/bin/sh
2 #
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be be taken to unexpected places.  If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
14 die() {
15         echo >&2 "$@"
16         exit 1
17 }
19 usage() {
20         die "Usage: $0 $USAGE"
21 }
23 set_reflog_action() {
24         if [ -z "${GIT_REFLOG_ACTION:+set}" ]
25         then
26                 GIT_REFLOG_ACTION="$*"
27                 export GIT_REFLOG_ACTION
28         fi
29 }
31 git_editor() {
32         GIT_EDITOR=${GIT_EDITOR:-$(git config core.editor || echo ${VISUAL:-${EDITOR}})}
33         case "$GIT_EDITOR,$TERM" in
34         ,dumb)
35                 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
36                 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
37                 echo >&2 "Please set one of these variables to an appropriate"
38                 echo >&2 "editor or run $0 with options that will not cause an"
39                 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
40                 exit 1
41                 ;;
42         esac
43         "${GIT_EDITOR:-vi}" "$1"
44 }
46 is_bare_repository () {
47         git rev-parse --is-bare-repository
48 }
50 cd_to_toplevel () {
51         cdup=$(git rev-parse --show-cdup)
52         if test ! -z "$cdup"
53         then
54                 cd "$cdup" || {
55                         echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
56                         exit 1
57                 }
58         fi
59 }
61 require_work_tree () {
62         test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
63         die "fatal: $0 cannot be used without a working tree."
64 }
66 get_author_ident_from_commit () {
67         pick_author_script='
68         /^author /{
69                 s/'\''/'\''\\'\'\''/g
70                 h
71                 s/^author \([^<]*\) <[^>]*> .*$/\1/
72                 s/'\''/'\''\'\'\''/g
73                 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
75                 g
76                 s/^author [^<]* <\([^>]*\)> .*$/\1/
77                 s/'\''/'\''\'\'\''/g
78                 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
80                 g
81                 s/^author [^<]* <[^>]*> \(.*\)$/\1/
82                 s/'\''/'\''\'\'\''/g
83                 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
85                 q
86         }
87         '
88         encoding=$(git config i18n.commitencoding || echo UTF-8)
89         git show -s --pretty=raw --encoding="$encoding" "$1" |
90         LANG=C LC_ALL=C sed -ne "$pick_author_script"
91 }
93 if [ -z "$LONG_USAGE" ]
94 then
95         LONG_USAGE="Usage: $0 $USAGE"
96 else
97         LONG_USAGE="Usage: $0 $USAGE
99 $LONG_USAGE"
100 fi
102 case "$1" in
103         -h|--h|--he|--hel|--help)
104         echo "$LONG_USAGE"
105         exit
106 esac
108 # Make sure we are in a valid repository of a vintage we understand.
109 if [ -z "$SUBDIRECTORY_OK" ]
110 then
111         : ${GIT_DIR=.git}
112         GIT_DIR=$(GIT_DIR="$GIT_DIR" git rev-parse --git-dir) || {
113                 exit=$?
114                 echo >&2 "You need to run this command from the toplevel of the working tree."
115                 exit $exit
116         }
117 else
118         GIT_DIR=$(git rev-parse --git-dir) || exit
119 fi
120 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}